#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"keddefs.h"
#include	"kedvars.h"
#include	"ksysprot.h"
#include	"kedfuncs.h"
/*EXTERN*/
/**/
doflags(is)
char 	*is;
{
	auto	int		nn1;	/* used to save address vars */
	auto	int		nn2;
	auto	int		nn3;
	auto	int		del = NO;
	auto	int		lst = cdx.lst;
	is = totext(is);
	if(strchr("#lLpsoOVvgcmdjw",*is) && nocards())  return(cdx.con = NO);
	switch(*is) {
	case    'v':
	case    'g':
		badadr(1,cdx.lst,1,cdx.lst);
		doglob(cdx.nn1,cdx.nn2,is);
		break;
	case	'o':
		badadr(cdx.cur,cdx.cur,1,cdx.lst);
		overlay(nn1 = cdx.nn1,nn2 = cdx.nn2,is);
		cdx.cur = nn2 - (lst - cdx.lst);
		del = YES;
		break;
	case    's':
		badadr(cdx.cur,cdx.cur,1,cdx.lst);
		kdosub(nn1 = cdx.nn1,nn2 = cdx.nn2,is);
		cdx.cur = nn2 - (lst - cdx.lst);
		del = YES;
		break;
	case	ZERO:	is[0] = 'Z';
					is[1] = ZERO;
	case    '#':
	case	'Z':
	case	'z':
	case	'T':
	case	't':
	case    'P':
	case    'p':
	case    'L':
	case    'l':
		badadr(cdx.cur,cdx.cur,1,cdx.lst);
		prlist(nn1 = cdx.nn1,nn2 = cdx.nn2,is);
		del = NO;
		break;
	case    'k':
		badadr(cdx.cur,cdx.cur,1,cdx.lst);
		domark(nn1 = cdx.nn1,nn2 = cdx.nn2,is+1);
		del = NO;
		break;
	case    'j':
		if(cdx.act == 0)    {
			cdx.nn1 = prevcd(cdx.cur);
			cdx.nn2 = cdx.nn1 + 1;
			}
		else
		if(cdx.act == 1)    {
			cdx.nn2 = cdx.nn1;
			cdx.nn1 = cdx.nn1 -1;
			}
		badadr(cdx.nn1,cdx.nn2,1,cdx.lst);
		dojoin(nn1 = cdx.nn1,nn2 = cdx.nn2,is);
		cdx.cur = nn2 - (lst - cdx.lst);
		del = YES;
		break;
	case    'a':
		if(cdx.act == 0)    cdx.nn2 = cdx.nn1 = cdx.cur;
		badadr(cdx.nn1,cdx.nn2,0,cdx.lst);
		append(nn1 = nn2 = cdx.nn1);
		cdx.cur = nn2 + (cdx.lst - lst);
		del = YES;
		break;
	case    'i':
		if(cdx.act == 0)    {
			cdx.nn2 = cdx.nn1 = cdx.cur >= 1 ? (cdx.cur - 1) : 0;
			}
		badadr(cdx.nn1,cdx.nn2,0,cdx.lst);
		append(nn1 = nn2 = cdx.nn1);
		cdx.cur = nn2 + (cdx.lst - lst);
		del = YES;
		break;
	case    'c':
		if(is[1] == 'o')    {
			badadr(cdx.cur,cdx.cur,1,cdx.lst);
			nn1 = cdx.nn1;
			nn2 = cdx.nn2;
			copyit(nn1,nn2,nn3 = pcmd1(is+2,cdx.cur));
			cdx.cur = nn3 + 1;
			del = YES;
			}
		else    {
			badadr(cdx.cur,cdx.cur,1,cdx.lst);
			dochg(nn1 = cdx.nn1,nn2 = cdx.nn2,is);
			cdx.cur = nn2 - (lst - cdx.lst);
			del = YES;
			}
		break;
	case    'd':
		badadr(cdx.cur,cdx.cur,1,cdx.lst);
		delcd(nn1 = cdx.nn1,nn2 = cdx.nn2,is);
		cdx.cur = (nn1 <= cdx.lst) ? nn1 : (nn1 -1);
		del = YES;
		break;
	case    '=':
		printff("%d\n",cdx.cur);
		del = NO;
		break;
	case    'm':
		badadr(cdx.cur,cdx.cur,1,cdx.lst);
		if(is[1] == 'v')    ++is;
		nn1 = cdx.nn1;
		nn2 = cdx.nn2;
		moveit(nn1,nn2,nn3 = pcmd1(is+1,cdx.cur));
		cdx.cur = nn3 +1;
		del = YES;
		break;
	case    'V':
			badadr(cdx.cur,cdx.cur,1,cdx.lst);
			kdovi(nn1 = cdx.nn1,nn2 = cdx.nn2,is);
			cdx.cur = nn2 - (lst - cdx.lst);
			del = YES;
			if(cdx.cur >= 1)	prlist(cdx.cur,cdx.cur,"Z");
			break;
	case	'C':
		badadr(1,cdx.lst,1,cdx.lst);
		docheck(nn1 = cdx.nn1, nn2 = cdx.nn2, is + 1);
		cdx.cur = nn2;
		cdx.del = NO;
		break;
	case    'w':
		badadr(1,cdx.lst,1,cdx.lst);
		if(strncmp(is,"w !",3) == 0) {
			dopipe(nn1 = cdx.nn1,cdx.nn2,is+3);
		}
		else {
			if(strcmp(is,"wq") == 0)    {
				dowrite("w",nn1 = 1,cdx.lst);
				doquit(is);
				}
			else    dowrite(is,nn1 = cdx.nn1,cdx.nn2);
		}
		cdx.cur = nn1;
		del = NO;
		break;
	case    'r':
		badadr(cdx.cur,cdx.cur,0,cdx.lst);
		doread(nn1 = nn2 = cdx.nn2,strcnd(is+1));
		cdx.cur = (cdx.lst > lst) ? (nn1 + 1) : cdx.cur;
		del = YES;
		break;
	default:
		errmsg("<unknown command> [%c] in [%s]\n",*is,is);
		if(kenv.prompt) printff("<use ? to see commands>\n");
		terror(FUBAR);
		break;
	}
/*
	all functions except global should write undo here
*/
	if(cdx.glb == NO && del)	{
		undo(BWRT,"doflags");
		if(cdx.lst > lst)	printff("%d more card(s)\n",cdx.lst-lst);
		else
		if(cdx.lst < lst)	printff("%d fewer card(s)\n",lst - cdx.lst);
		}
	return(ZERO);
}
/**/
void
badadr(n1,n2,n3,n4)   /* set default address; check specified address */
int	n1;
int	n2;
int	n3;
int	n4;
{
/*
**  this routine is badly named and should be split into
**  two separate functions
*/
	if(cdx.act == 0)	{
		cdx.nn1 = n1;
		cdx.nn2 = n2;
		cdx.act = 1;
		}
	if(cdx.nn1 > cdx.nn2) 	bumadr(">",cdx.nn1,cdx.nn2);
	else
	if(cdx.nn1 < n3) 		bumadr("<",cdx.nn1,n3);
	else
	if(cdx.nn2 > n4) 		bumadr(">",cdx.nn1,n4);
	return;
}
nocards()
{
	if(cdx.lst <= 0) {
		errmsg("<no cards>\n");
		terror(FUBAR);
		}
	return(ZERO);
}
void
bumadr(is,n1,n2)
char	*is;
int		n1;
int		n2;
{
	errmsg("<illegal address> %d %s %d\n",n1,is,n2);
	terror(FUBAR);
	return;
}
docheck(n1,n2,is)	/* integrity check on cards */
int		n1;
int		n2;
char	*is;
{
	auto	NOSIGN	ix;
	for(ix = n1; cdx.con && ix <= n2; ix++)	{
		if(getcd(ix,CARD_IO))	{
			cdx.con = NO;
			cdx.cur = ix;
			terror(FUBAR);
			}
		}
	return(cdx.con);
}
