#include    "ksysdefs.h"
#include    "ksysvtyp.h"
/**/
#include    "keddefs.h"
#include	"kedvars.h"
#include	"ksysprot.h"
#include    "kedfuncs.h"
/**/
#include	"kedbuffr.h"
/**/
/*EXTERN*/
extern 		char 	*cpsx;
/**/
doglob(n1,n2,is)		/* build global list */
int	n1;
int	n2;
char    *is;
{
	REG 	int 	i;
	auto	int	nr = 0;
	auto	int	nf = 0;
	auto	int	ty = 'g';
/**/
	flagsoff(cbt,cdx.lst);
/**/
	if(cdx.glb == YES) {
		errmsg("<nested global>\n");
		terror(FUBAR);
	}
/**/
	cdx.glb = YES;
	cpsx = is;
	ty = *cpsx++;
	switch(*cpsx)	{
	case	'/':
	case	'?':	if(pullp(cpsx))   	return(cdx.con = NO);
					break;
	case	'%':	if(pullh(cpsx))		return(cdx.con = NO);
					ty = '%';
					break;
	default:		errmsg("doglob <bad type> '%c'\n",ty);
					terror(FUBAR);
					break;
	}
	for(i = n1; i <= n2; i++) {
		cdx.cur = i;
		if(ty == 'v')   {
			getcd(i,LINE_IO);
			nr = re_exec(kb.base);
			if(!nr)     {
				cbt[i].tags.glob = YES;
				nf += 1;
				}
			}
		else
		if(ty == 'g')   {
			getcd(i,LINE_IO);
			nr = re_exec(kb.base);
			if(nr)      {
				cbt[i].tags.glob = YES;
				nf += 1;
				}
			}
		else
		if(ty == '%')	{
			if(re_hash(i))			{
				cbt[i].tags.glob = YES;
				nf += 1;
				}
			}
		}
/**/
	if(kenv.prompt) {
		if(nf)  printff("<%d global matches>\n",nf);
		else    printff("<no global matches>\n");
		}
/**/
	if(nf <= 0) {
		return(cdx.con=cdx.glb=NO);
		}
	else	{
		xglob(n1,n2,cpsx);
		return(cdx.con);
		}
/**/
}
char	*
xglob(n1,n2,is)		/* execute global */
int	n1;
int	n2;
char    *is;
{
	REG		int		n = 0;
	REG		int		del = 0;
	REG		int		l = 0;
	REG		int		lst = cdx.lst;
	auto	char    	ws[FNMSIZ];
	do  {
		l = 0;
		n = n1;
		do
		{
		if(cbt[n].tags.glob == YES)
			{
			cbt[n].tags.glob = NO;
			cdx.nn1 = cdx.nn2 = cdx.cur = cdx.sve = n;
			pcmd0(strcpy(ws,is));
			l = 1;
			del += cdx.del;
			}
		else    {
			n = nextcd(n);
			}
		}   while(n != n1 && cdx.con && cdx.glb)  ;
		n1 = 1;
	}   while(l && cdx.con == YES)  ;
	flagsoff(cbt,cdx.lst);
	if(del) {
		undo(BWRT,"xglob");
		}
	if(kenv.prompt) {
	if(cdx.lst < lst)
		printff("%d fewer cards after global\n",lst - cdx.lst);
	if(cdx.lst > lst)
		printff("%d more cards after global\n",cdx.lst - lst);
	}
	cdx.glb = NO;
	return(cpsx);
}
