#include    "ksysdefs.h"
#include    "ksysvtyp.h"
/**/
#include	"keddefs.h"
#define		ALLOCATE
#include	"kedvars.h"
#include	"ksysprot.h"
#include	"kedfuncs.h"
#include	"keyproto.h"
#include    <setjmp.h>
#include    <signal.h>
/**/
#include	"kedbuffr.h"
/**/
#ifdef          MSDOS
#include        "ksysgtty.h"
#else           MSDOS
#include    	<sgtty.h>
#endif          MSDOS
/**/
jmp_buf     	here;
NOSIGN			max_error = 0;
void
sigsegv(ty)
int		ty;
{
	errmsg("<probable NULL in call to function>\n");
	terror(ty);
}
void
terror(ty)
int		ty;
{
/**/
	disnme(kenv.pname = "ked");
/**/
	signal(SIGINT,SIG_IGN);
/**/
#ifdef	SIGHUP
	if(ty == SIGHUP)		kenv.prompt = 0;
#endif	/*SIGHUP*/
/**/
	if(ecnt++ >= FNMSIZ)	kenv.prompt = 0;	/* force quit */
/**/
	fflush(stdout);
	diskreset();
/**/
	efclean(bfp);              /* close open files */
	ifb = free_if(ifb);
	ofb = free_if(ofb);
/* CHECK */
/**/
#ifdef	FLAGSOFF
	flagsoff(cbt,cdx.lst);      /* turn off global flags */
#endif
/**/
	clcd();                     /* clear card memory */
	cbc_off(fileno(stdin));		/* terminal reset */
/**/
	kenv.prompt = kenv.prompt && isatty(0) && isatty(1) ? 1 : 0;
/**/
	if(kenv.prompt)     {
		if(ty == FUBAR)	query(stderr);
		else			prwho(" terror(%u)\n",ty);
		longjmp(here,1);
		}
	else
	if(bfp)				kedexit("xq");		/* save buffer if possible */
	else                doquit("q!");
/**/
}
main(argc,argv)
int     argc;
char    *argv[];
{
	auto    int     first = 0;
/**/
	if(cmderr(argc,argv,"0123456789BDLRThikrsu"))	exit(FUBAR);
/**/
	kenv.blockd = cmdnum(argc,argv,'B',8,8) * bufsiz();
	kenv.flags0 = cmdnum(argc,argv,'L',1,0);
/**/
	kenv.diagno = cmdnum(argc,argv,'D',0,1);
/**/
	rawmode();
/**/
	kenv.dosdos = isdos();
/**/
	disnme(kenv.pname = "ked");
/**/
	disrec(cmdnum(argc,argv,'R',1,0));
/**/
	if(kenv.dosdos)	cmdxpd(argc,argv);
	else			telluser(kenv.pname);
/**/
	cansyn = 1;
	cantime = ecnt = nupr = canecho = 0;
	kenv.folder = 56;
/**/
	setbuf(stdout,sob = emalloc(bufsiz(),"main"));
/* CHECK */
/**/
	if(isatty(1))	{
		kenv.prompt = DA | DB;
		if(baudrate(stdin) >= 1200)
			clear = kenv.leisur = DA | DB;
		}
/**/
	if(cmdnum(argc,argv,'h',0,1))    {
		if(isatty(1))	{
			whoru(stdout);
			sleep(2);
			}
		khint("ked","");
		khint("kedhash","");
		khint("kedio","");
		khint("edcd","");
		exit(0);
		}
/**/
	ub.canund = cmdnum(argc,argv,'u',DA,DA);
/**/
	if(SIG_IGN == signal(SIGINT,(FUNCS) terror))	{
		errmsg("<cannot run %s in background>\n",
			kenv.pname);
		exit(FUBAR);
		}
/**/
	setjmp(here);
/**/
	signal(SIGINT,(FUNCS) terror);
	signal(SIGSEGV,(FUNCS) sigsegv);
/**/
	fuset((FUNCP) cterror);
/**/
	signal(SIGTERM,(FUNCS) terror);
#ifdef	SIGHUP
	signal(SIGHUP,(FUNCS) terror);
#endif	/*SIGHUP*/
#ifdef	SIGPIPE
	signal(SIGPIPE,(FUNCS) terror);
#endif	/*SIGPIPE*/
/**/
	if(first++ <= 0)	{
/**/
		if(kenv.prompt)	{
			whoru(stdout);
			query(stdout);
			}
/**/
		set_tmp_dir(cmdstr(argc,argv,'T',NULL));
/**/
		keysread(keysfile(cmdstr(argc,argv,'k',NULL)));
/**/
		envhash();
/**/
		kedexrc();
/**/
		if(kenv.keying)	firstfile(argc,argv);
		}
/**/
	rdcmd(stdin,kenv.prompt);
/**/
	doexit(0);
/**/
}
void
whatkey(is)		/* list keys or read new keys file */
char	*is;
{
	if(isnull(is))	keyslist();
	else			{
		keysread(keysfile(is));
		envhash();
		}
}
void
kedexrc()   /* look for .kedexrc file */
{
	extern	char	*findfile();
	auto	char	*have = NULL;
	auto	char	*home = kgetenv("HOME");
	auto	char	*pubs = kgetenv("PUBKIN");
	auto	int		pr;
	if(kenv.dosdos)	have = findfile("ked.xrc",3,".",home,pubs);
	else	{
		have = findfile(".kedxrc",3,".",home,pubs);
		if(isnull(have))	{
			have = findfile(".kedexrc",3,".",home,pubs);
			}
		}
	if(!isnull(have))	{
		pr = kenv.prompt;
		kenv.prompt = 0;
		doso(have);
		kenv.prompt = pr;
		free_if(have);
		}
}
void
firstfile(argc,argv)    /* setup buffer for first file or recovery */
int     argc;
char    *argv[];
{
	auto	char	ws[FNMSIZ];
	auto	char	*df = "biblbibl.ked";
	auto	char	*dr = "biblbibl.rec";
	if(cmdnum(argc,argv,'r',0,1))   {
		strcpy(ws,cmdstr(argc,argv,'r',dr));
		doreco(ws);
		return;
		}
	else
	if(cmdnum(argc,argv,'i',0,1))   {
		strcpy(ws,cmdstr(argc,argv,'i',df));
		doedit(ws);
		}
	else
	if(cmdnum(argc,argv,'s',0,1))	{
		auto	FUNCP	fu;
		auto	char	*sf = cmdstr(argc,argv,'s',df);
		static	struct	SUFFIX	{
			char	*sn;
			FUNCP	su;
			}	suf[] = {
			".rec",doreco,
			".ked",doedit,
			".not",doedit,
			"",doedit,
			NULL,NULL,
			}	;
		auto	struct	SUFFIX	*sux = suf;
		while(sux->sn)	{
			sprintf(ws,"%s%s",sf,sux->sn);
			if(access(ws,04) == ZERO)	{
				fu = sux->su;
				(*fu)(ws);
				tellfile(TERSE);
				return;
				}
			sux += 1;
			}
		strcpy(ws,sf);
		doedit(ws);
		tellfile(TERSE);
		return;
		}
	else                            {
		strcpy(ws,df);
		doedit(ws);
		}
	cdx.del = cdx.chg = 0;
	tellfile(TERSE);
	return;
}
