#include    "ksysdefs.h"
#include    "ksysvtyp.h"
/**/
#include    "keddefs.h"
#include	"kedvars.h"
#include	"ksysprot.h"
#include	"kedfuncs.h"
#include	"kedbuffr.h"
/**/
#include    <signal.h>
/**/
/*EXTERN*/
/**/
wrcards(mo,is,n1,n2)
char    *mo;
char    *is;
int     n1;
int		n2;
{
	extern		long		ftell();
    auto        FILE        *ofp = NULL;
    auto        NOSIGN      count = 0;
    auto        long      	total = 0;
    auto        NOSIGN      i = 0;
    auto		int			canwrite = 1;
	auto		FUNCS		sigint;
	auto		FUNCS		sighup;
	auto		long		cadr;
	auto		long		ladr;
/**/
	if(isnull(bfn) || access(bfn,04))	{
		errmsg("<no readable buffer>\n");
		exit(FUBAR);
		}
/**/
	ofp = tefopen(is,mo);
/**/
	is[1] == ':' ? is[0] : 0;
#ifdef	SYSV
	ofb = ksetvbuf(ofp,ofb,_IOFBF,kenv.blockd);
#endif	/*SYSV*/
/* CHECK */
/**/
	sigint = (FUNCS) signal(SIGINT,SIG_IGN);
#ifdef	SIGHUP
	sighup = (FUNCS) signal(SIGHUP,SIG_IGN);
#endif	/*SIGHUP*/
/**/
	total = n2 - n1 + 1;
/**/
	ladr = 0L;
	rewind(bfp);
/**/
	fputs("\n",ofp);
    for(i = n1; canwrite && i <= n2; i++) {
		cadr = cbt[i].addr;
		if(cadr != ladr)	efseek(bfp,cadr,0);
		xrdcd(kb.base,kb.bmax,bfp);
        xwrcd(kb.base,ofp);
        count++;
		if(kenv.prompt && count % 100 == 0)	{
			auto	long	pcent;
			pcent = (long) count * 100;
			pcent /= total;
			printff("%6d %2ld%%\r",count,pcent);
			}
		ladr = ftell(bfp) + 1L;
        }
	xfclose(ofp);
/**/
	signal(SIGINT,(FUNCS) sigint);
#ifdef	SIGHUP
	signal(SIGHUP,(FUNCS) sighup);
#endif	/*SIGHUP*/
/**/
	if(canwrite == 0)	{
		errmsg("dowrite <error on output>\n");
		errmsg("dowrite <save buffer with x command>\n");
		sleep(10);
		terror(FUBAR);
		}
/**/
	strunx(is);
	strunx(efn);
    if(n1 == 1 && n2 == cdx.lst &&
        strcmp(is,efn) == 0)    {
			cdx.chg = 0;
			undo(BWRT,"wrcards");
			undo(BWRT,"wrcards");
			gut(is);
			sut(bfn);
			}
    if(kenv.prompt) {
        printff("%d cards to %s\n",count,is);
    }
	ofb = free_if(ofb);
    return(ZERO);
}
dowrite(is,n1,n2)   /* write (and rebuild) */
int     n1;
int     n2;
char    *is;
{
    auto    char    ws[FNMSIZ];
    auto    char    *wsx = ws;
    strcpy(ws,is);
/*	
	order of these is important; dowrite is called with
	wFILE, w!FILE, w>>FILE, etc.
*/
    if(strncmp(ws,"w>>",3) == 0) {
        wrcards("a",wrnset(wsx+3),n1,n2);
        }
    else
    if(strncmp(ws,"w!",2) == 0) {
        wrcards("w",wrnset(wsx+2),n1,n2);
        }
	else
    if(strcmp(ws,"w") == 0) {
		wsx = wrnset(wsx+1);
		if(n1 !=1 || n2 != cdx.lst)	{
			errmsg("write partial buffer with 'w! %s'\n",wsx);
			terror(FUBAR);
			}
        wrcards("w",wsx,n1,n2);
        }
	else
    if(strncmp(ws,"w",1) == 0) {
		wsx = wrnset(wsx+1);
        if(access(wsx,0) == 0) {
            errmsg("overwrite with 'w! %s'\n",wsx);
            terror(FUBAR);
            }
        wrcards("w",wsx,n1,n2);
        }
	else
	if(strncmp(ws,"w !",3) == 0)	{
		dopipe(n1,n2,ws+3);
		terror(FUBAR);
		}
    else    {
        errmsg("<bad form> '%s'\n",ws);
        terror(FUBAR);
    }
    return(cdx.con = YES);
}
char	*
wrnset(is)
char	*is;
{
	auto	char	*file;
	if(isnull(is))	return(strcpy(is,efn));
	else	{
		file = fexpand(is);
		strcpy(is,file);
		file = free_if(file);
		}
	return(is);
}
/**/
#ifdef	MSDOS
dopipe(n1,n2,is)
int		n1;
int		n2;
char	*is;
{
		errmsg("<w! not usable with MSDOS>\n");
		terror(FUBAR);
		return(ZERO);
}
#else	MSDOS
dopipe(n1,n2,is)
int	n1;
int	n2;
char    *is;
{
	REG		int	i;
	if(cdx.glb == YES)  {
		errmsg("<w! not usable with v or g>\n");
		terror(FUBAR);
		}
	strcnd(is);
	if((ofp = epopen(is,"w")) == (FILE*) NULL)   {
/* CHECK */
		prterr("<%s>",is);
		terror(FUBAR);
		}
	for(i = n1; i <= n2; i++) {
		getcd(i,LINE_IO);
		xwrcd(kb.base,ofp);
		}
	xfclose(ofp);
	return(cdx.con = YES);
}
#endif	MSDOS
