#define		ALLOCATE
#include	"ktheader.h"
/**/
#define		DEBUG
#undef		DEBUG
/*DOSLIB*/
/*UNXLIB*/
/**/
void
terror(ty)
int		ty;
{
	exit(ty);
}
main(argc,argv)
int 	argc;
char	*argv[];
{
	kenv.dosdos = isdos();
	disnme(kenv.pname = "ktree");
/**/
#ifdef	DEBUG
	setbuf(stdout,NULL);
#else
	setbuf(stdout,emalloc(bufsiz(),"main"));
#endif
/**/
	if(!kenv.dosdos)	telluser(kenv.pname);
/**/
	kenv.leisur = isatty(1) ? (DA | DB) : 0;
	kenv.screen = 22;
/**/
	if(cmdnum(argc,argv,'h',0,1))   {
		if(kenv.leisur)	{
			whoru(stdout);
			query(stdout);
			}
		hint(0);
		}
/**/
#ifdef	__TURBOC__
/*
|	without this code, the first call to stat() always gives the wrong
|	time, off by the time zone differential (?)
*/
	{
	auto	long	now;
	time(&now);
	ctime(&now);
	}
#endif	/*__TURBOC__*/
/**/
	getdir(argc,argv);
/**/
	getprg(argc,argv);
/**/
	time(&curt);
#ifdef	DEBUG
	fprintf(stderr,"curt %lu %s",curt,ctime(&curt));
#endif
/**/
#ifdef	__TURBOC__
	setcbrk(YES);
#endif	/*TURBOC*/
/**/
#ifdef	TRACE
	if(kenv.tracer & DA)	allcode("main");
#endif
/**/
	doscan(dlist,ndir);
/**/
	fflush(stdout);
/**/
	return(0);
}
getprg(argc,argv)
int		argc;
char	**argv;
{
	auto	int		ix = 1;
/**/
	prx = prog;
/**/
	argu = argv + argc;		/* upper limit */
	while(ix < argc && argv[ix] == NULL)	ix++;
	argx = argv + ix;		/* beginning of commands */
/**/
	while(argx < argu)	argx = cexpr(argx);
/**/
	prx++->func = STOP;
	prx++->func = STOP;
	prx++->func = STOP;
/**/
	return(prx - prog);
}
void
fscan(is)
char    *is;
{
	auto	PROG		*save;
	auto    int     	nr;
/**/
	if(kenv.dosdos)	{
		strxty(is,'\\','/');
		strlwr(is);
		}
/**/
#ifdef	MSDOS
/*
	damn msdos does not treat root as a directory!
*/
	if(is[1] == ':' && is[2] == ZERO)	{
		dscan(is);
		return;
		}
	else
	if(is[0] == '.' && is[1] == ZERO)	{
		dscan(is);
		return;
		}
#endif
/**/
	nr = stat(is,&sbuf);
/**/
	if(nr < 0)		{
		errmsg("fscan <cannot stat> '%s'\n",is);
		return;
		}
/**/
	cfn = is;
#ifdef	FNAME
	getfname(fname,fname+FNMSIZ,cfn);
#else	/*FNAME*/
#endif	/*FNAME*/
/**/
	pru = prx;
	prx = prog;
	sp = stack;
/**/
	xecute();
/**/
	if((sbuf.st_mode & S_IFMT) == S_IFDIR)  dscan(is);
#ifdef	MSDOS
	else
	if((sbuf.st_mode & 0600) == S_IFDIR)  	dscan(is);
#endif
/**/
	return;
}
char	**
cexpr(argv)		/* compile one expression */
char	**argv;
{
	argv = corlist(argv);
	return(argv);
}
char	**
corlist(argv)
char	**argv;
{
	argv = candlist(argv);
	while(argv < argu && *argv)	{
		if(strncmp(*argv,"-o",2) == 0)	{
			auto	PROG	*save;
			prx++->func = orlist;
			save = prx++;
			argv = candlist(++argv);
			save->next = prx;
			}
		else	break;
		}
	return(argv);
}
char	**
candlist(argv)
char	**argv;
{
	auto	PROG	*save;
	argv = cprimary(argv);
	while(argv < argu && *argv)	{
/*###ktmain.c(170) : warning 47: `==' : different levels of indirection???*/
		if(intree(*argv) || **argv == '!') {
			argv = cprimary(argv);
			}
		else	break;
		}
	return(argv);
}
char	**
cprimary(argv)
char	**argv;
{
	auto	TREE	*tx;
	if(**argv == '(')	{
		prx++->func = xecute;
		argv = cexpr(++argv);
		if(**argv != ')')	{
			errmsg("cprimary <missing paren>\n");
			terror(FUBAR);
			}
		argv += 1;
		prx++->func = STOP;
		}
	else
	if(**argv == '!')		{
		prx++->func = negate;
		argv = cprimary(++argv);
		}
	else
	if(tx = intree(*argv))	{
		argv += 1;
		prx++->func = tx->fun;
		if(tx->ppf)	argv = (*tx->ppf)(argv);
		}
	else					{
		errmsg("cprimary <syntax error> (%s)\n",*argv);
		terror(FUBAR);
		}
	return(argv);
}
void
xecute()
{
	auto	int		ret;
	while(prx->func != STOP)	{
if(kenv.tracer & DA)
		showcode(prx,"0 xecute");
		(*prx++->func)();
if(kenv.tracer & DA)
		showcode(prx,"1 xecute");
		if(prx->func == orlist)		(*prx++->func)();
if(kenv.tracer & DA)
		showcode(prx,"2 xecute");
		ret = *--sp;
		if(!ret)					break;
		}
	prx += 1;
	*sp++ = ret;
	return;
}
void
negate()
{
	auto	int		ret = 0;
	(*prx++->func)();
	ret = *--sp;
	*sp++ = !ret;
	return;
}
void
andlist()
{
	auto	int		ret;
	auto	PROG	*save;
	save = prx++->next;
	ret = *--sp;
	if(ret)		(*prx++->func)();
	else		{
		*sp++ = ret;
		prx = save;
		}
	return;
}
void
orlist()
{
	auto	int		ret;
	auto	PROG	*save;
	save = prx++->next;
if(kenv.tracer & DA)
	showcode(prx,"0 orlist");
	ret = *--sp;
	if(!ret)	(*prx++->func)();
	else		{
		*sp++ = ret;
		prx = save;
		}
if(kenv.tracer & DA)
	showcode(prx,"1 orlist");
	return;
}
