#define		TIMEIT
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#include	"ksyskwik.h"
#define		ALLOCATE
#include	"kwikhash.h"
/*STATIC*/
#define		KWIKMAGIC	890318L
static		long		magic = KWIKMAGIC;
USHORT		numt;
/*EXTERN*/
#ifdef	CAN_PROTO
extern void writelist(USHORT,char *,USHORT,DADR,FILE *);
extern char *setxfn(char *);
extern int notsame(long,long,char *,char *);
extern int estat(char *,STAT *);
extern int findhash(DADR *,USHORT,char *, USHORT);
extern int hashlist(char *,USHORT,char *);
extern int fileloop(char *);
#else	/*CAN_PROTO*/
extern void writelist();
extern char *setxfn();
extern int notsame();
extern int estat();
extern int findhash();
extern int hashlist();
extern int fileloop();
extern void writelist();
#endif	/*CAN_PROTO*/
#ifndef	SYSV
#undef	SETVBUF
#endif	/*SYSV*/
/**/
void
dohash()	/* MAKE A SEARCH USING THE HASH INDEX TABLE */
{
/**/
	if(!kenv.ndexed)	{
		errmsg("dohash <no current index>\n");
		terror(FUBAR);
		}
/**/
	if(isnull(curkpc))	{
		errmsg("dohash <no pattern>\n");
		terror(FUBAR);
		}
/**/
	if(kenv.flags7 && iscommon(curpat))	terror(FUBAR);
/**/
/*SWEEP*/
	findword(curpat);
/**/
	return;
}
/**/
findword(is)
char	*is;
{
	auto	long	tbeg;
	auto	long	tend;
	auto	USHORT	head;
	auto	USHORT	ix;
	auto	char	cfn[FNMSIZ];
	auto	char	word[FNMSIZ];
	auto	USHORT	csize;
	auto	USHORT	numh = 0;
	auto	long	addr;
	static	char	*crap;
	static	char	*list;
	auto	USHORT	numd;
	auto	USHORT	have;
	auto	char	*bufx;
	auto	STAT	sbx;
	auto	STAT	sbc;
	auto	USHORT	granularity;
	auto	USHORT	used = 0;
	auto	USHORT	pass = 0;
/**/
	xfp = xfclose(xfp);
	xfp = tefopen(xfn,"r");
#ifdef	SETVBUF
	xfb = setvbuf(xfp,xfb,_IOFBF,kenv.blockd);
#endif	/*SETVBUF*/
	rfn = free_if(rfn);
/**/
	csize = (USHORT) modfac / 8;
	csize = ((USHORT) modfac % 8) ? (csize +1) : csize;
	crap = free_if(crap);
	list = free_if(list);
	list = emalloc(csize,"findword");
	crap = emalloc(csize,"findword");
	memset( crap, 0, csize );
/**/
	if(!isnull(is))	numh = hashlist(list,csize,is);
/**/
	if(!isnull(is))	kpc(word,word+FNMSIZ-1,is);
/**/
	rewind( xfp );
	fread( (char *) &magic, sizeof(long), 1, xfp);
	if(magic != KWIKMAGIC)	{
#ifdef	D_MAGIC
		fprintf(stderr,"%ld %ld ",magic,KWIKMAGIC);
#endif	/*D_MAGIC*/
		errmsg("findword <index has bad magic number>\n");
		terror(FUBAR);
		}
	fread( (char *) &modfac, sizeof(long), 1, xfp);
	fread( (char *) &granularity, sizeof(USHORT), 1, xfp);
	kenv.flags2 = granularity;
/**/
	loop = 1;
/**/
	time(&tbeg);
/**/
	while(loop && !feof(xfp))	{
		fread( (char *) &head, sizeof(USHORT), 1, xfp);
		if(head == strhash("file"))	{
			ifp = xfclose(ifp);
			ifb = free_if(ifb);
/**/
			counts.curf = 0;
/**/
			fread( ifn = cfn, sizeof(char), FNMSIZ, xfp);
			rfn = stradd( rfn, cfn );
			fread( (char *) &sbx, sizeof(STAT), 1, xfp);
			if(estat(cfn,&sbc))	terror(FUBAR);
			notsame(sbx.st_mtime,sbc.st_mtime,cfn,"mod time");
			if(notsame(sbx.st_size,sbc.st_size,cfn,"size")) terror(FUBAR);
/**/
			ifp = tefopen(cfn,"r");
#ifdef	SETVBUF
	ifb = setvbuf(ifp,ifb,_IOFBF,kenv.blockd);
#endif	/*SETVBUF*/
			continue;
			}
/**/
		fread( crap, sizeof(char), csize, xfp);
		fread( (char *) &addr, sizeof(DADR), 1, xfp);
/**/
		if(isnull(is))	continue;
/**/
		for(have = ix = 0; ix < csize; ix++)	{
			have = (list[ix] & crap[ix]) ? (have +1 ) : have;
			}
/**/
		if(have == numh)	{
			used += 1;
			numd = kenv.flags2;
			for(ix = 0; loop && ix < numd; ix++)	{
				bufx = (*rdfunc) (kb.base,kb.bmax,ifp);
				if(bufx == NULL)	{
					break;	/* not a full block */
					}
				bufx += 1;
				kpc(bufx,kb.bmax,kb.base);
				counts.curf += 1;
				if(kpx(bufx,word))	{
					vwriter();
					/* xwrcd(kb.base,stdout); */
					}
				}
			}
		else	{
			pass += 1;
			/* printf("skip to %ld\n",addr); */
			efseek( ifp, addr, 0);
			counts.curf += granularity;
			}
		}
/**/
	ifp = xfclose(ifp);
	ifb = free_if(ifb);
	xfp = xfclose(xfp);
	xfb = free_if(xfb);
	crap = free_if(crap);
	list = free_if(list);
/**/
	time(&tend);
/**/
#ifdef	TIMEIT
	if(kenv.timing)	{
		fprintf(stderr,"%ld seconds ",tend - tbeg);
		fprintf(stderr,"total %u used %u passed %u\n",
			used + pass, used, pass);
		}
#endif	/*TIMEIT*/
/**/
}
notsame(xv,cv,os,is)
long	xv;
long	cv;
char	*os;
char	*is;
{
	auto	int		ret = 0;
	if(xv != cv)	{
		errmsg("<index != current for %s> '%s'\n",is,os);
		ret = 1;
		}
	return(ret);
}
hashlist(list,csiz,is)
char	*list;
USHORT	csiz;
char	*is;
{
	auto	char	word[FNMSIZ];
	auto	char	*isx = is;
	auto	USHORT	hash;
	auto	USHORT	blit;
	auto	USHORT	byte;
	auto	USHORT	numh = 0;
	memset( list, 0, csiz );
	while(isx = xgnw(word,word+FNMSIZ-1,isx))	{
		hash = strhash( word );
		byte = hash / 8;
		blit = hash % 8;
		if( (list[byte] & (1 << blit)) == 0)	{
			list[byte] |= (1 << blit);
			numh += 1;
			}
		}
	return(numh);
}
fileloop(is)
char	*is;
{
	auto	char	*isx = is;
	auto	char	ws[FNMSIZ];
	auto	char	*wsu = ws + FNMSIZ -1;
	auto	USHORT	head = strhash("file");
	auto	STAT	sb;
	auto	USHORT	granularity = kenv.flags2;
/**/
	xfp = xfclose(xfp);
	xfp = tefopen(xfn,"w");
#ifdef	SETVBUF
	xfb = setvbuf(xfp,xfb,_IOFBF,kenv.blockd);
#endif	/*SETVBUF*/
/**/
#ifdef	D_MAGIC
fprintf(stderr,"%ld\n",magic);
#endif	/*D_MAGIC*/
	fwrite( (char *) &magic, sizeof(long), 1, xfp);
	fwrite( (char *) &modfac, sizeof(long), 1, xfp);
	fwrite( (char *) &granularity, sizeof(USHORT), 1, xfp);
/**/
	numt = strcnt(rfn,' ') + 1;
/**/
	while(isx = xgnc(ws,wsu,isx,' '))	{
#ifdef	TIMEIT
		if(kenv.timing & DA)	timeit(0,"xonefile");
#endif	/*TIMEIT*/
		if(estat(ws,&sb))		terror(FUBAR);
		fwrite( (char *) &head, sizeof(USHORT), 1, xfp);
		fwrite( ws, sizeof(char), FNMSIZ, xfp);
		fwrite( (char *) &sb, sizeof(STAT), 1, xfp);
		ifp = tefopen(ws,"r");
#ifdef	SETVBUF
	ifb = setvbuf(ifp,ifb,_IOFBF,kenv.blockd);
#endif	/*SETVBUF*/
		if(kenv.prompt)	drawset(sb.st_size,50,'=','X','>');
		xonefile(ifp,numf);
		numf += 1;
		ifp = xfclose(ifp);
		ifb = free_if(ifb);
#ifdef	TIMEIT
		if(kenv.timing & DA)	timeit(1,"xonefile");
#endif	/*TIMEIT*/
		}
/**/
	if(kenv.prompt)	drawclear(stderr);
/**/
	xfp = xfclose(xfp);
	xfb = free_if(ifb);
/**/
	return(numf);
}
estat(is,sb)
char	*is;
STAT	*sb;
{
	auto	int		ret;
	if(ret = stat(is,sb))	{
		prterr(is);
		}
	return(ret);
}
xonefile(fp,numf)
FILE	*fp;
USHORT	numf;
{
	auto	char	word[MAXWORD];
	auto	USHORT	card = 0;
	auto	char	*bufx;
	auto	DADR	addr = 0L;
	auto	USHORT	hash;
	static	char	*barf;
	auto	USHORT	csize;
	auto	USHORT	byte;
	auto	USHORT	blit;
	auto	USHORT	head = strhash("index");
/**/
#ifdef	TIMEIT
	if(kenv.timing) timeit(0,"\none block");
#endif	/*TIMEIT*/
/**/
	csize = (USHORT) (modfac / 8L);
	csize = (modfac % 8L) ? (csize + 1) : csize;
	barf = free_if(barf);
	barf = emalloc(csize,"xonefile");
	memset(barf,0,csize);
/**/
	while(1)	{
		addr = ftell(fp);
		if(!(*rdfunc) (bufx = kb.base,kb.bmax,fp))		break;
		if(rdfunc == xrdcd && (kenv.flags0 & DA))		{
			zapkeys(bufx);
			}
		while(bufx = xgnw(word,word+MAXWORD-1,bufx))	{
			if((kenv.flags7 & DA) && infilter(word)) continue;
			hash = strhash( word );
			byte = hash / 8;
			blit = hash % 8;
			if(!(barf[byte] & (1 << blit)))	{
				barf[byte] |= (1 << blit);
				}
		}
		card += 1;
		if(card % kenv.flags2 == 0)	{
			writelist(head,barf,csize,addr,xfp);
			if(kenv.prompt)	{
				drawline(numf + 1,numt,addr,stderr);
				}
#ifdef	TIMEIT
	if(kenv.timing)	{
		timeit(1,"\none block");
		timeit(0,"\none block");
		}
#endif	/*TIMEIT*/
			}
	}
	if(card % kenv.flags2) {	/* flush */
		writelist(head,barf,csize,addr,xfp);
#ifdef	TIMEIT
	if(kenv.timing)	{
		timeit(1,"\none block");
		}
#endif	/*TIMEIT*/
		}
/**/
	barf = free_if(barf);
/**/
	return(card);
}
void
writelist(head,list,csize,addr,ofp)
USHORT	head;
char	*list;
USHORT	csize;
DADR	addr;
FILE	*ofp;
{
#ifdef	DEBUG
	howmany(list,csize);
#endif	/*DEBUG*/
	fwrite( (char *) &head, sizeof(USHORT), 1, ofp);
	fwrite( list, sizeof(char), csize, ofp);
	fwrite( (char *) &addr, sizeof(DADR), 1, ofp);
	memset( list, 0, csize);
	return;
}
howmany(list,csize)
char	*list;
USHORT	csize;
{
	auto	USHORT	ix;
	auto	USHORT	jx;
	auto	USHORT	tx;
	for(tx = ix = 0; ix < csize; ix++)	{
		for(jx = 0; jx < 8; jx++)	{
			if(list[ix] & ( 1 << jx ))	tx += 1;
			}
		}
	fprintf(stderr,"tx %u\n",tx);
}
makeindex(ty,is)		/* INDEX THE CURRENT INPUT FILE LIST */
int		ty;
char	*is;
{
	auto	char	ws[FNMSIZ];
	if(ty == 's')	{
		if(!kenv.ndexed)	{
			errmsg("<no index to save>\n");
			terror(FUBAR);
			}
		if(isnull(is))		{
			errmsg("<no name for saved index>\n");
			terror(FUBAR);
			}
		strcpy(ws,is);
		xpandsh(ws,ws+FNMSIZ-1);
		if(strcmp(ws,xfn))	{
			if(access(ws,04) == 0)	{
				errmsg("<use Z to remove existing file> %s\n",ws);
				terror(FUBAR);
				}
			linkorcopy(xfn,ws);
			}
		xfp = xfclose(xfp);
		xfb = free_if(xfb);
		xfn = free_if(xfn);
		kenv.ndexed = 0;
		}
	else
	if(ty == 'u')	{
		xfp = xfclose(xfp);
		xfb = free_if(xfb);
		kenv.ndexed = 0;
		setxfn(is);
#ifdef	BUILDLIST
		buildlist(NULL);
#endif	/*BUILDLIST*/
		findword(NULL);
		kenv.ndexed = 1;
		}
	else
	if(ty == 'x')	{
		if(isnull(rfn))	{
			errmsg("<no input files specified>\n");
			terror(FUBAR);
			}
		xfp = xfclose(xfp);
		xfb = free_if(xfb);
		kenv.ndexed = 0;
		setxfn(is);
		if(access(xfn,0) == 0)	{
			errmsg("<use Z to remove existing file> %s\n",xfn);
			terror(FUBAR);
			}
#ifdef	BUILDLIST
		buildlist(NULL);
#endif	/*BUILDLIST*/
		fileloop(rfn);
		kenv.ndexed = DA;
		}
	else
	if(ty == 'Z')	{
		xfp = xfclose(xfp);
		xfb = free_if(xfb);
		if(!isnull(xfn)) 	unlink(xfn);
		else				unlink("kwikfind.ind");
		kenv.ndexed = 0;
		xfn = free_if(xfn);
		}
	return(0);
/**/
}
char	*
setxfn(is)		/* SET THE INDEX FILE NAME */
char	*is;
{
	auto	char	ws[FNMSIZ];
	xfn = free_if(xfn);
	if(isnull(is))	xfn = strsave("kwikfind.ind");
	else	{
		strcpy(ws,is);
		xpandsh(ws,ws+FNMSIZ-1);
		xfn = strsave(ws);
		}
	return(xfn);
}
