/*COMLIB*/
#define		DEBUG
#undef		DEBUG
#include    "ksysdefs.h"
#include    "ksysvtyp.h"
#include	"ksysprot.h"
/**/
#define		HUGE		9999
/*EXTERN*/
/*STATIC*/
#ifdef	CAN_PROTO
extern char *range(int,char *);
extern void errmsg();
#else
extern void errmsg();
char *range();
#endif
#ifdef  TEST
main()
{
    auto    char    ls[FNMSIZ];
    auto    char    fn[FNMSIZ];
    auto    char    tp[FNMSIZ];
	auto	char	*rs;
    auto    int     nr;
    while(putchar('?'),gets(ls))
    switch(ls[0])   {
    case    '>':    strcpy(tp,ls+1);
                    break;
    case    '<':    strcpy(fn,ls+1);
                    break;
    case	'*':    nr = bshpat(fn,tp);
                    printf("%d = bshpat(%s,%s)\n",nr,fn,tp);
                    break;
	case	'?':
	default:		
					puts("<string  set 'file name'");
					puts(">string  set 'pattern'");
					puts("*        test pattern");
					break;
    }
}
#endif
/**/
#define     DASH    '-'
#define     ANYONE  '?'
#define     ALLPAT  '*'
#define     BRANGE  '['
#define     ERANGE  ']'
#define     NOTSET  '^'
/**/
bshpat(os,is)       /* Bourne shell style pattern matching */
char    *os;		/* file name */
char    *is;		/* pattern */
{
    register        char    *isx = is;
    register        char    *osx = os;
/**/
	if(*osx == ZERO || *isx == ZERO)	return(ZERO);
/**/
    while(*isx != ZERO)    {
        if(*isx == ANYONE)     	{
        	if(*osx == ZERO)	return(ZERO);
        	isx += 1;
        	osx += 1;
        	continue;
        	}
        else
        if(*isx == ALLPAT)  {
			if(*osx == '/')		return(ZERO);
			if(*osx == ZERO)	return(1);
			if(isx[1] == ZERO)	return(1);
            while(*osx != ZERO)
            	if(bshpat(osx++,isx+1)) return(1);
		isx += 1;
		}
		else
        if(*isx == BRANGE)  {
            isx = range(*osx,isx+1);
            if(!isx)                    return(0);
            else                        osx += 1;
            }
        else
        if(*isx == *osx)                {++isx; ++osx;}
        else                            return(0);
    }
    if(*osx == *isx)                    return(1);
    else                                return(0);
}
char    *
range(cx,is)
int     cx;
char    *is;
{
    register    char    *isx = is;
    register    int     nr = 0;
    auto        int     rs = 0;
#ifdef	TEST
	fprintf(stderr,"range(%c,%s)\n",cx,is);
#endif
/**/
    if(*isx == NOTSET)  rs = *isx++;
/**/
    while(!nr && *isx != ZERO && *isx != ERANGE)    {
    if(*isx == (char) cx)  nr = 1;
    else
    if(isx[1] == DASH && isx[0] < isx[2])   {
        if(cx >= isx[0] && cx <= isx[2])    nr = 1;
        else                                isx += 3;
        }
    else    isx += 1;
    }
#ifdef	TEST
	fprintf(stderr,"range: return(%d)\n",nr);
#endif
/**/
    while(*isx != ZERO && *isx != ERANGE)   ++isx;
/**/
#ifndef TEST
    if(*isx != ERANGE)  {
        errmsg("range <missing right bracket>\n");
        fubar(FUBAR);
        }
#endif
/**/
    if(rs == NOTSET)    nr = !nr;
/**/
#ifdef	TEST
	fprintf(stderr,"range: return(%d)\n",nr);
#endif
	if(nr)	return(isx+1);
	else	return(NULL);
}
