/*COMLIB*/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
/**/
extern		KENV	kenv;
/**/
cmdnum(argc,argv,fc,nd,yd)
int argc, nd, yd, fc;
char    **argv;
{
/*PARAMETERS
**  fc  =   flag character
**  nd  =   default value if flag absent
**  yd  =   defualt value if flag but no associated valued
*/
	char    *is;
	/* give nr 'no' default value */
	int     nr = nd;
	while(--argc)
	/* find '-' flagged strings */
	if(*++argv && **argv == '-')
		{
		/* loop through string */
		is = *argv + 1;
		while(*is != ZERO)
			/* is it the flag character ? */
			if(*is == (char) fc)
				{
				++is;
				/* give nr 'yes' default value */
				nr = yd;
				/* is there a number ? */
				if(isdigit(*is))    nr = atoi(is);
				/* skip number */
				while(isdigit(*is)) is++;
				}
			else    is++;
		}
	return(nr);
}
#ifdef  TEST
int a, b, c;
main(argc,argv)
int     argc;
char    **argv;
{
	a = cmdnum(argc,argv,'a',1,10);
	b = cmdnum(argc,argv,'b',2,20);
	c = cmdnum(argc,argv,'c',3,30);
	printf("%d %d %d\n",a,b,c);
}
#endif
