/*UNXLIB*/
/*DOSLIB*/
/* ============================================================ */
/*
	routines for stepping through directories.  these are not
	available in the XENIX cross compiler. For TurboC, its
	library routines are used (reluctantly).
*/
/* ============================================================ */
#ifdef		MSDOS
#ifdef		__TURBOC__
#else		/*__TURBOC__*/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
/**/
#include	<dos.h>
/**/
#define		SLASH	'/'
/**/
#define		PATHSEP	'\\'
#define		ZERO	0
#define		SHELLV	'$'
#define		DFILES	0x6
#define		DVOLUM	0x8
#define		DDIREC	0x10
#define		DARCHV  0x20
#define		SETDTA	0x1a		/* set disk transfer address */
#define		FNDONE	0x4e		/* first first */
#define		FNDNXT	0x4f		/* find next */
#define		GOTONE	0			/* found one (no error) */
#define		NOMORE	18			/* no more files */
#define		DTASIZ	43			/* size of dta */
union	REGS	regi;
union	REGS	rego;
typedef	struct	FFBLK	{
	char	ff_dos[21];		/* dos work area */
	char	ff_attrib;		/* file attribute */
	int		ff_ftime;		/* file time */
	int		ff_fdata;		/* file time */
	long	ff_fsize;		/* file size */
	char	ff_fname[13];	/* file name */
	}	FFBLK;
/**/
/*EXTERNAL*/
extern	char	*dosxenv();
extern	char	*ksetdta();
extern	char	*kgetdta();
/**/
char	*
kgetdta()		/* return disk transfer area */
{
	regi.h.ah = 0x2f;
	intdos(&regi,&rego);
	return((char*) rego.x.bx);
}
char	*
ksetdta(is)		/* set the disk transfer area */
char	*is;
{
	regi.h.ah = 0x1a;
	regi.x.dx = (int) is;
	intdos(&regi,&rego);
	return(is);
}
findnext(dta)	/* find the next file matching findfirst pattern */
char	*dta;
{
	ksetdta(dta);
	regi.h.ah = (char ) FNDNXT;
	intdos(&regi,&rego);
	if(rego.x.cflag)	return(rego.x.ax);	/* no more */
	else				return(0);	/* got one */
}
findfirst(is,dta,ty)	/* find first matching file */
char	*is;		/* path */
char	*dta;		/* dta */
int	ty;		/* attributes */
{
	ksetdta(dta);
	regi.h.ah = FNDONE;
	regi.x.dx = (int) is;
	regi.x.cx = ty;
	intdos(&regi,&rego);
	if(rego.x.cflag)	return(rego.x.ax);	/* none or error */
	else				return(0);	/* got one */
}
#endif		/*__TURBOC__*/
#else		/*MSDOS*/
#define	ZERO	0
kgetdta(){return(ZERO);}
ksetdta(){return(ZERO);}
findnext(){return(ZERO);}
findfirst(){return(ZERO);}
#endif		/*MSDOS*/
