#include	"pdtar.h"
#include	"pdproto.h"
/**/
void
tar_eof()			/* write two all null blocks for eof */
{
	static	char	*here = "tar_eof";
	auto	char	buf[BLKSIZ];
	memset(buf, 0, BLKSIZ);
	tar_place(buf,1,here);
	tar_place(buf,1,here);
	return;
}
tar_write(ty)		/* open or close the archive */
int		ty;
{
/*
	unless the output file is openned with O_SYNCW, writes are
	buffered by the kernel.  if the output device is a floppy and
	it is write protected, the kernel loops.
*/
#ifdef	M_XENIX
	static	int		oflag  = O_SYNCW | O_CREAT | O_WRONLY | O_BINARY;
#else	/*M_XENIX*/
	static	int		oflag  = O_CREAT | O_WRONLY | O_BINARY;
#endif	/*M_XENIX*/
	static	int		mode = 0700;
	static	char	*here = "tar_write";
/**/
	if(oswitch.rawio)				{
		rawreset(device.rawd);
		return(0);
		}
	else
	if(ty == T_OPEN)		{
		if(dstrcmp(afn,"-") == 0)	device.ofd = fileno(stdout);
		else						{
			device.ofd = open(afn,oflag | O_TRUNC, mode);
			pwhoami = &whoami;
			if(badstat(afn,pwhoami,here))		terror(FUBAR);
			if(!(pwhoami->st_mode & S_IFREG))	pwhoami = NULL;
			}
		}
	else
	if(ty == T_CLOSE)				{
		device.ofd = device.ofd ? close(device.ofd) : device.ofd;
		}
	else							abort();
	if(device.ofd < 0)	{
		where(here);
		perror(afn);
		terror(FUBAR);
		}
#ifdef	DEBUG
	{
	extern	long	filesize();
	fprintf(stderr,"tar_write(%u,%ld) ofd(%u)\n",ty,filesize(afn),
		device.ofd);
	}
#endif
	return(ty);
}
tar_read(ty)		/* open or close archive when extracting */
int		ty;
{
	static	char	*here = "tar_read";
/**/
#ifdef	DEBUG
	fprintf(stderr,"%d %s\n",dstrcmp(afn,"-"),afn);
#endif	/*DEBUG*/
	if(dstrcmp(afn,"-") == 0)	device.ifd = fileno(stdin);
	else
	if(oswitch.rawio)			{
		rawreset(device.rawd);
		device.ifd = 0;
		}
	else
	if(ty == T_OPEN)			device.ifd = open(afn,O_RDONLY | O_BINARY,0);
	else
	if(ty == T_CLOSE)			device.ifd = close(device.ifd);
	else						abort();
	if(device.ifd < 0)	{
		where(here);
		perror(afn);
		terror(FUBAR);
		}
/**/
	return(ty);
}
#ifdef	DEBUG
long
filesize(is)
char	*is;
{
	struct	stat	sb;
	stat(is,&sb);
	return(sb.st_size);
}
#endif
