/*DOSLIB*/
/*UNXLIB*/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
/*DEFINE*/
#define		WHO_AM_I		"flc"
#define		ROPEN			0
#define		RCLOSE			1
#define		RCLEAN			2
#define		CMARK			'&'
/*EXTERN*/
extern	int		flc();
extern	int		rbld();
extern	int		comp();
extern	int		xpnd();
extern	int		flc();
/*GLOBAL*/
KENV		kenv;
FILE		*ofp = stdout;
char		ls[BUFSIZ];
char		ps[BUFSIZ];
char		ws[BUFSIZ];
/*STATIC*/
void
terror(ty)
int		ty;
{
	rbld(RCLEAN);
	exit(ty);
}
hint(ty)
int		ty;
{
	static	char	*hx[] = {
	"=flc [-options] [file(s)]",
	"*",
	"*       compress/decompress files having repeated lines",
	"*",
	"=OPTIONS",
	"-d      decompress",
	"-c      compress",
	"-r0     do not rebuild",
	"-r1     rebuild [default]",
	"=",
	"=BUGS",
	"*",
	"*       output is always UNIX format",
	"=",
	"~",
	}	;
	prhint(hx,sizeof(hx)/sizeof(char*),ZERO,ZERO);
	return(ty);
}
main(argc,argv)
int		argc;
char	*argv[];
{
	kenv.dosdos = isdos();
	disnme(kenv.pname = WHO_AM_I);
	exit(cmdxrc(argc,argv,flc,"flc.xrc"));
}
flc(argc,argv)
int		argc;
char	*argv[];
{
/*	DIAGNOSTIC SET */
	kenv.diagno = cmdnum(argc,argv,'D',0,DA);
/*	PARAMETER EXPANSION, LOGGING */
	if(kenv.dosdos)	cmdxpd(argc,argv);
	else			telluser(kenv.pname);
/**/
	disrec(cmdnum(argc,argv,'R',1,0));
/*	BUFFER STDOUT */
	setbuf(stdout,emalloc(bufsiz(),"main"));
/*	PROMPT */
	kenv.prompt = isatty(0) && isatty(1);
/*	LEISURE */
	kenv.leisur = (kenv.prompt && baudrate(stdout) >= 1200) ? (DA | DB) : 0;
/*	HINT FUNCTION */
	if(cmdnum(argc,argv,'h',0,DA))	{
		if(kenv.prompt)	{
			whoru(stdout);
			sleep(2);
			}
		exit(hint(0));
		}
	kenv.flags0 = cmdnum(argc,argv,'r',1,0);
	kenv.report = cmdnum(argc,argv,'v',1,0);
/* ============================================================ */
	if(cmdnum(argc,argv,'c',0,DA))	dolist(argc,argv,comp);
	else
	if(cmdnum(argc,argv,'d',0,DA))	dolist(argc,argv,xpnd);
	else							exit(hint(FUBAR));
/* ============================================================ */
	return(ZERO);
}
rbld(ty,is)
int		ty;
char	*is;
{
	auto	char	*wm = kenv.dosdos ? "wb" : "w";
	static	char	ws[FNMSIZ];
	static	char	*td = NULL;
	static	long	fi;
	static	long	fo;
	if(!td)				{
		td = (int) (td = kgetenv("TMPDIR")) ? td : ".";
		strcpy(ws,td);
		strcat(ws,"/fcXXXXXX.tmp");
		maketemp(ws);
		}
	if(ty == ROPEN)		{
		ofp = efopen(ws,wm);
		}
	else
	if(ty == RCLOSE)	{
		ofp = xfclose(ofp);
		fi = filesize(is);
		linkorcopy(ws,is);
		fo = filesize(is);
		}
	else
	if(ty == RCLEAN)	{
		unlink(ws);
		}
	if(ty == RCLOSE && kenv.report)	{
		fprintf(stderr,"%ld -> %ld %s\n",fi,fo,is);
		}
	return(ty);
}
xpnd(fp)
FILE	*fp;
{
	auto	int		nc;
	if(kenv.flags0)	rbld(ROPEN);
	while(fgetlf(ls,ls+BUFSIZ-1,fp))	{
		if(ls[0] == CMARK)	{
			nc = ls[1] - 'A';
			strcpy(ws,ps);
			strcpy(ws+nc,ls+2);
			strcpy(ls,ws);
			}
		fputs(ls,ofp);
		fputs("\n",ofp);
		strcpy(ps,ls);
		}
	ls[0] = ps[0] = ws[0] = ZERO;
	if(kenv.flags0)	rbld(RCLOSE,getcfn());
	return(ZERO);
}
comp(fp)
FILE	*fp;
{
	auto	int		nc;
	if(kenv.flags0)	rbld(ROPEN);
	while(fgetlf(ls,ls+BUFSIZ-1,fp))	{
		if(ls[0] == ps[0] && ((nc = substr(ps,ls)) >= 3))	{
			fprintf(ofp,"%c%c%s\n",CMARK,nc + 'A',ls + nc);
			}
		else	{
			fputs(ls,ofp);
			fputs("\n",ofp);
			}
		strcpy(ps,ls);
		}
	ls[0] = ps[0] = ws[0] = ZERO;
	if(kenv.flags0)	rbld(RCLOSE,getcfn());
	return(ZERO);
}
substr(os,is)
register	char	*os;
register	char	*is;
{
	auto	short	nc = 0;
	while(*is != 0 && *os == *is)	{
		is += 1;
		os += 1;
		nc += 1;
		}
	return(nc);
}

