/*DOSLIB*/
/*UNXLIB*/
#define		EXPAND
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#define		HEADFOOT	6
/*EXTERN*/
#ifdef	CAN_PROTO
extern char *ctime(long *);
extern char *fgetlt(char *, char *, FILE *);
extern char *pfputs(char *, FILE *);
extern int footer(char *);
extern int header(char *);
extern void hint(int);
extern int holdscreen(int);
extern int pageit(FILE *);
extern int pager(int, char **);
extern long time(long *);
#else	/*CAN_PROTO*/
extern char *ctime();
extern char *fgetlt();
extern char *pfputs();
extern int footer();
extern int header();
extern void hint();
extern int holdscreen();
extern int pageit();
extern int pager();
extern long time();
#endif	/*CAN_PROTO*/
/*GLOBAL*/
KENV		kenv;
char		ls[BUFSIZ];
int			pl;
int			pn;
long		tnow;		/* current time and date */
char		tstr[32];	/* current time and data as string */
/**/
holdscreen(lc)
int		lc;
{
	if(lc % kenv.screen)	return(ZERO);
	fflush(stdout);
	if(query(stdout) == 'q')	exit(0);
	return(ZERO);
}
pageit(fp)
FILE	*fp;
{
	auto	int	xl;
	auto	int	ln = 0;
/**/
	pn = 0;
/**/
	while(!feof(fp))	{
/**/
/**/
		pn += 1;
/**/
		xl = pl - (2 * HEADFOOT);
		header(getcfn());
/**/
		while(xl && fgetlt(ls,ls+BUFSIZ-1,fp))	{
			ln += 1;
			if(kenv.flags0 & DA)	fprintf(stdout,"%4d    ",ln);
			pfputs(ls,stdout);
			if(kenv.dosdos)		fputs("\r\n",stdout);
			else			fputs("\n",stdout);
			xl -= 1;
			if(kenv.screen)	holdscreen(ln);
			}
/**/
		while(xl)	{
			putc(LF,stdout);
			xl -= 1;
			}
/**/
		footer(getcfn());
		}
/**/
	fflush(stdout);
	return(ZERO);
}
char	*
pfputs(is,fp)
char	*is;
FILE	*fp;
{
	auto	char	*isx = is;
	auto	int		pw = ZERO;
	while(*isx != ZERO)
	if(*isx == '\t' && kenv.buffer)	{
		auto	int		tabs = pw % kenv.buffer;
		while(tabs++ < kenv.buffer)	{
			putc(' ',fp);
			pw += 1;
			}
		++isx;
		}
	else	{
		pw += (isprint(*isx)) ? 1 : ((*isx == '\b') ? -1 : 0);
		putc(*isx++,fp);
		}
	return(is);
}
char 	*
fgetlt(os,us,fp)
char	*os;
char	*us;
FILE	*fp;
{
	auto	char	*osx = os;
	auto	char	*usx = us - 1;
	auto	int		pw = ZERO;
	auto	int		cx;
	while(osx < usx && (cx = getc(fp)) != EOF)
	if(cx == CR)	;
	else
	if(cx == LF)	break;
	else
	if(kenv.folder && isspace(cx) && pw >= kenv.folder)	{
		ungetc('>',fp);
		break;
		}
	else
	if(cx == '\t' && kenv.buffer)	{
		auto	int		tabs = pw % kenv.buffer;
		while(osx < usx && tabs++ < kenv.buffer)	{
			*osx++ = ' ';
			pw += 1;
			}
		}
	else	{
		pw += (isprint(cx)) ? 1 : ((cx == '\b') ? -1 : 0);
		*osx++ = cx;
		}
	*osx++ = ZERO;
	if(osx >= usx)	{
/* ### Warning pager.c 140: Call to function 'errmsg' with no prototype in function fgetlt === */
		errmsg("fgetlt <long line>\n");
		exit(FUBAR);
		}
	return(osx);
}
footer(is)
char	*is;
{
	fputs("\n\n\n\n\n\n",stdout);
	return(ZERO);
/* ### Warning pager.c 150: Parameter 'is' is never used in function footer === */
}
header(is)
char	*is;
{
	auto	char	*fn;
	if(isnull(is))	is = "<stdin>";
	if(kenv.dosdos)	strxty(is,'\\','/');
	fn = strrchr(is,'/');
	if(!fn)	fn = is;
	fputs("\n\n",stdout);
	fprintf(stdout,"%s %s Page %d\n",tstr,fn,pn);
	fputs("\n\n\n",stdout);
	return(ZERO);
}
void
terror(ty)
{
	exit(ty);
}
main(argc,argv)
int	argc;
char	*argv[];
{
	kenv.dosdos = isdos();
	disnme(kenv.pname = "pager");
	exit(cmdxrc(argc,argv,pager,"pager.xrc"));
/* ### Warning pager.c 176: Function should return a value in function main === */
}
pager(argc,argv)
int		argc;
char	*argv[];
{
/**/
	if(kenv.dosdos)	cmdxpd(argc,argv);
	else			telluser(kenv.pname);
/**/
	disrec(cmdnum(argc,argv,'R',1,0));
/**/
	setbuf(stdout,emalloc(bufsiz(),"main"));
	time(&tnow);
	if(cmdnum(argc,argv,'h',0,1))	{
		hint(ZERO);
		}
	strcpy(tstr,strcnd(ctime(&tnow)));
	pl = cmdnum(argc,argv,'p',66,66);
	kenv.screen = cmdnum(argc,argv,'P',isatty(1) * 22, 22);
	kenv.flags0 = cmdnum(argc,argv,'l',0,DA);
	{
	auto	char	*tabstop = kgetenv("TABSTOP");
	if(tabstop)	kenv.buffer = atoi(tabstop);
	else		kenv.buffer = 4;
	kenv.buffer = cmdnum(argc,argv,'T',kenv.buffer,kenv.buffer);
	}
	kenv.folder = cmdnum(argc,argv,'F',0,56);
	dolist(argc,argv,pageit);
	exit(0);
/* ### Warning pager.c 205: Function should return a value in function pager === */
}
void
hint(ty)
int		ty;
{
static	char	*hx[] = {
"=pager [options] [file(s)]",
"*       break files into logical pages.  label with file name,",
"*       date of printing, and page number.",
"*       this program gives msdos a subset of the functions",
"*       provided by the UNIX utility pr.",
"=OPTIONS",
"-FNN    fold on first space after NN lines [0]",
"-P0     do not pause",
"-PNN    pause after NN lines",
"-TN     expand tabs [default 4]",
"-h      list options",
"-l      number lines (begin at 1 for each file)",
"-pNN    page length to NN [66]",
"=LIMITS",
"*       input lines 512 characters or less",
"=MSDOS VERSION",
"        expands wildcards in command line file names.",
"=",
}	;
	prhint(hx,sizeof(hx)/sizeof(char**),NULL,ZERO);
	exit(ty);
	return;
}



