/*
**  routine names in the format
**  last_name, first_name; last_name, first_name
*/
#include    "ksysdefs.h"
#include    "ksysvtyp.h"
#include    "kawkdefs.h"
/**/
#include	"ksysprot.h"
#include	"kawkfunc.h"
/**/
/*EXTERN*/
/*STATIC*/
static          rc = ';';       /* subfield character */
/**/
rnamec(cc)                      /* set rname character */
int     cc;
{
    return(rc = cc);
}
char	*
reverse(os,us,is)
char	*os;
char	*us;
char	*is;
{
	auto	char	*scx;	/* SEMICOLON */
	auto	char	*fcx;	/* FIRST COMMA */
	auto	char	*ncx;	/* NEXT COMMA */
	REG		char	*osx = os;
	REG		char	*usx = us;
	strkat(osx,usx,is);
	do	{
		scx = strchr(osx,SEMICOLON);
		if(scx)	*scx = ZERO;
		fcx = strchr(osx,COMMA);
		if(fcx)	{
			ncx = strchr(fcx+1,COMMA);
			if(ncx)	*ncx = ZERO;
			strrev(osx);
			fcx = strchr(osx,COMMA);
			*fcx = ZERO;
			strrev(osx);
			strrev(fcx+1);
			*fcx = BLANK;
			if(ncx)	*ncx = COMMA;
			}
		if(scx)	*scx = SEMICOLON;
		osx = scx + 1;
	}	while(scx);
	rcond(os);
	return(os);
}
char	*
rcond(is)
char	*is;
{
	REG		char	*isx = is;
	REG		char	*osx = is;
	while(isspace(*isx))		++isx;
	while(*isx != ZERO)
	if(isspace(*isx))	{
		while(isspace(*isx))	++isx;
		if(*isx != ZERO)		*osx++ = BLANK;
		}
	else						*osx++ = *isx++;
	*osx = ZERO;
	return(is);
}
char	*
andlist(os,us,is)
char	*os;
char	*us;
char	*is;
{
	auto	char	*lsx;	/* LAST SEMICOLON */
	strkat(os,us,is);
	lsx = strrchr(os,SEMICOLON);
	if(lsx)	{
		*lsx++ = COMMA;
		strrev(lsx);
		strkat(lsx+strlen(lsx),us," dna ");
		strrev(lsx);
		strxty(os,SEMICOLON,COMMA);
		rcond(os);
		}
	return(os);
}
#ifdef  TEST
main()
{
    char    line[BUFSIZ];
    char    rine[BUFSIZ];
    while(fputc('?',stderr),gets(line))
    {
    reverse(rine,&rine[BUFSIZ-1],line);
    andlist(rine,&rine[BUFSIZ-1],rine);
    puts(rine);
    }
}
#endif
