#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#define		ALLOCATE
#include	"ksysgrph.h"
#include	<setjmp.h>
#include	<signal.h>
/**/
#define			IPNULL		((int *) ZERO)
/**/
/*EXTERN*/
void	terror();
void	catchsig();
/**/
jmp_buf here;
/**/
void
terror(ty)
int		ty;
{
	catchsig();
	return;
}
void
catchsig()
{
	signal(SIGINT,SIG_IGN);
	if(ifp)	{
		fclose(ifp);
		ifp = NULL;
		}
	if(kenv.prompt <= 0)	{
		errmsg("<killed>\n");
		exit(1);
		}
	longjmp(here,1);
}
typedef	struct	FSETS	{
	char	*fname;		/* function name */
	int		fnsize;		/* size of function for compare */
	int		ftype;		/* function type */
	int		(*sfunc)();	/* function for set or execution */
	int		*vpoint;	/* address of variable to set */
	int		*wflag;		/* address of warning flag */
	}	FSETS;
FSETS	fs[] = {
"so",2,'a',doso,IPNULL,IPNULL,
"help",4,'a',help,IPNULL,IPNULL,
"h",1,'a',help,IPNULL,IPNULL,
"?",1,'a',help,IPNULL,IPNULL,
"exit",4,'a',doexit,IPNULL,IPNULL,
"quit",1,'a',doexit,IPNULL,IPNULL,
"diag",4,'i',setivar,&kenv.diagno,NULL,
"!sh",3,'a',xdoshell,IPNULL,IPNULL,
"!",1,'a',xdoshell,IPNULL,IPNULL,
"DOC",3,'t',toggle,&kenv.flags2,IPNULL,
"ECHO",4,'t',toggle,&kenv.flags1,IPNULL,
"NOTES",5,'t',toggle,&kenv.flags3,IPNULL,
"display",7,'a',display,IPNULL,IPNULL,
"form",4,'a',setform,IPNULL,IPNULL,
"doc",3,'t',toggle,&kenv.flags2,IPNULL,
"echo",4,'t',toggle,&kenv.flags1,IPNULL,
"expand",6,'a',doexpand,IPNULL,IPNULL,
"ghead=",6,'s',setstr,(int *) ghead,IPNULL,
"graph",5,'a',dograph,IPNULL,IPNULL,
"infile=",7,'s',setstr,(int *) ifn,IPNULL,
"inform=",7,'s',setstr,(int *) fm,IPNULL,
"limits",6,'a',display,IPNULL,IPNULL,
"lx=",3,'i',setivar,(int *) &lx,&redraw,
"ly=",3,'i',setivar,(int *) &ly,&redraw,
"ndx=",4,'i',setivar,(int *) &ndx,&redraw,
"ndy=",4,'i',setivar,(int *) &ndy,&redraw,
"notes",5,'t',toggle,&kenv.flags3,IPNULL,
"nsfx=",5,'i',setivar,(int *) &nsfxx,IPNULL,
"nsfy=",5,'i',setivar,(int *) &nsfyy,IPNULL,
"print",5,'a',doprint,IPNULL,IPNULL,
"read",4,'a',doread,IPNULL,IPNULL,
"set",3,'a',doset,IPNULL,IPNULL,
"shrink",6,'a',doshrink,IPNULL,IPNULL,
"symdraw=",8,'i',setsym,&symdraw,&redraw,
"symfill=",8,'i',setsym,&symfill,&redraw,
"xmax=",5,'d',setdvar,(int *) &xmax,&redraw,
"xmin=",5,'d',setdvar,(int *) &xmin,&redraw,
"xscale=",5,'d',setdvar,(int *) &xscale,&redraw,
"xtitle=",7,'s',setstr,(int *) xtitle,IPNULL,
"xvar=",5,'i',setivar,(int *) &xvar,&ndread,
"ymax=",5,'d',setdvar,(int *) &ymax,&redraw,
"ymin=",5,'d',setdvar,(int *) &ymin,&redraw,
"yscale=",5,'d',setdvar,(int *) &yscale,&redraw,
"ytitle=",7,'s',setstr,(int *) ytitle,IPNULL,
"yvar=",5,'i',setivar,(int *) &yvar,&ndread,
	}	;
FSETS	*fsc;
FSETS	*fsb = fs;
FSETS	*fsu = fs + sizeof(fs)/sizeof(FSETS);
extern	FSETS	*fsetsget();
main(argc,argv)
int		argc;
char	*argv[];
{
	extern	int		kgraph();
	exit(cmdxrc(argc,argv,kgraph,"kgraph.xrc"));
}
kgraph(argc,argv)
int 	argc;
char 	*argv[];
{
	ob = emalloc(bufsiz(),"main");
	kenv.dosdos = isdos();
	disnme(kenv.pname = "kgraph");
	if(isatty(fileno(stdin)))	{
		setbuf(stdout,ob);
		kenv.prompt = 1;
		kenv.leisur = DA | DB;
		}
	else kenv.prompt = 0;
/**/
	if(cmdnum(argc,argv,'h',0,DA))	{
		if(isatty(1))	{
			whoru(stdout);
			query(stdout);
			}
		help(NULL);
		exit(0);
		}
/**/
	if(cmdnum(argc,argv,'a',0,1))		{
		strcpy(ofn,cmdstr(argc,argv,'a',"grXXXXXX.tmp"));
		if(!(ofp = efopen(ofn,"a")))	exit(FUBAR);
		}
	else
	if(cmdnum(argc,argv,'w',0,1))		{
		strcpy(ofn,cmdstr(argc,argv,'w',"grXXXXXX.tmp"));
		if(!(ofp = efopen(ofn,"w")))	exit(FUBAR);
		}
	else	{
		strcpy(ofn,maketemp("grXXXXXX.tmp"));
		if(!(ofp = efopen(ofn,"w")))	exit(FUBAR);
		}
/**/
	strcpy(fm,"free");
	gform(formg);
	xyswap = 0;	/* if == 1 switch xx and yy variables */
	setgraph(lx,ly,ndx,ndy,xmin,xmax,ymin,ymax);
	redraw = 0;
/**/
	if(kenv.prompt)	whoru(stdout);
/**/
	/* interrupts return here */
	setjmp(here);
	signal(SIGINT,catchsig);
	if(kenv.prompt)	{
		prwho(" ? lists commands\n");
		}
	rdcmd(stdin);
	doexit();
	exit(0);
}
rdcmd(fp)
FILE	*fp;
{
	auto	char	ls[BLKSIZ];
	auto	int	prompt = isatty(fileno(fp));
	while(!feof(fp))	{
	if(prompt)	{
		fflush(stdout);
		print("(%s)=> ",kenv.pname);
		}
	if(!fgetlf(ls,ls+MAXREC,fp))	{
		if(prompt)	{
			errmsg("<use q to quit>\n");
			clearerr(fp);
			catchsig();
			}
		fclose(fp);
		}
	fsc = fsetsget(ls);
	if(!fsc)	{
		errmsg("<unknown request> '%s'\n",ls);
		catchsig();
		}
	if(fsc->ftype == 's')	(*fsc->sfunc)((char *) fsc->vpoint,ls);
	else
	if(fsc->ftype == 'a')	(*fsc->sfunc)(ls);
	else
	if(fsc->ftype == 'd')	(*fsc->sfunc)(ls,(double *) fsc->vpoint);
	else
	if(fsc->ftype == 'i')	(*fsc->sfunc)(ls, fsc->vpoint);
	else
	if(fsc->ftype == 't')	*fsc->vpoint = toggle(*fsc->vpoint);
	if(fsc->wflag)			*fsc->wflag = 1;
	}
	return(ZERO);
}
char	*
setstr(os,is)
char	*os;
char	*is;
{
	while(*is++ != '=')	;
	return(strcpy(os,is));
}
double
setdvar(is,ty)
char	*is;
double	*ty;
{
	while(*is++ != '=')	;
	return(*ty = atof(is));
}
setsym(is,ty)
char	*is;
int		*ty;
{
	while(*is++ != '=')	;
	if(*is == ZERO)	return(*ty = ' ');
	else			return(*ty = *is);
}
setivar(is,ty)
char	*is;
int		*ty;
{
	while(*is++ != '=')	;
	return(*ty = atoi(is));
}
toggle(ty)
int	ty;
{
	if(ty)	return(0);
	else	return(1);
}
doexit()
{
	extern	long	filesize();
	fclose(ofp);
	if(filesize(ofn) >= 1L)	prwho(" <print file> '%s'\n",ofn);
	else					unlink(ofn);
	if(kenv.prompt)			prwho(" <user terminated>\n");
	exit(0);
}
xisy(x,y)
char	*x,*y;
{
	if(strcmp(x,y) == 0) return(1);
	else return(0);
}
typedef	struct	PV	{
	int		*vp;
	char	*vn;
	char	*vf;
	}	PV;
PV	pv[] = {
&lx,"lx","%d",
&ndx,"ndx","%d",
&ly,"ly","%d",
&ndy,"ndy","%d",
(int *) &xmin,"xmin","%g",
(int *) &xmax,"xmax","%g",
(int *) &ymin,"ymin","%g",
(int *) &ymax,"ymax","%g",
(int *) &xlower,"xlower","%g",
(int *) &xupper,"xupper","%g",
(int *) &xrange,"xrange","%g",
(int *) &ylower,"ylower","%g",
(int *) &yupper,"yupper","%g",
(int *) &yrange,"yrange","%g",
&xpand,"expand","%d",
&shrink,"shrink","%d",
&formg,"form","%d",
&symdraw,"symdraw","%c",
&symfill,"symfill","%c",
(int *) ifn,"in file","%s",
(int *) ofn,"out file","%s",
(int *) fm,"format","%s",
&xvar,"xvar","%d",
&yvar,"yvar","%d",
(int *) &xscale,"xscale","%g",
(int *) &yscale,"yscale","%g",
(int *) ghead,"ghead","%s",
(int *) xtitle,"xtitle","%s",
(int *) ytitle,"ytitle","%s",
}	;
display()
{
	auto	int	ix;
	auto	char	*vf;
	scr_cl(stdout);
	printf("\n");
	for(ix = 0; ix < sizeof(pv)/sizeof(PV); ix++)	{
	vf = pv[ix].vf;
	switch(vf[1])	{
		case	'g':	printf("%10.10s ",pv[ix].vn);
						printf(vf, *((double *) pv[ix].vp));
						break;
		case	'c':	printf("%10.10s ",pv[ix].vn);
						printf(vf, *((int *) pv[ix].vp));
						break;
		case	'd':	printf("%10.10s ",pv[ix].vn);
						printf(vf, *((int *) pv[ix].vp));
						break;
		case	's':	printf("%10.10s ",pv[ix].vn);
						printf(vf, (char *) pv[ix].vp);
						break;
		}
	printf("\n");
	if( ix && (ix % 15) == 0)	{
		printf("\n");
		if(query(stdout) == 'q')	catchsig();
		else						scr_cl(stdout);
		printf("\n");
		}
	}
	fflush(stdout);
	return(0);
}
doexpand(is,ty)
char	*is;
int	*ty;
{
	while(*is++ != '=')	;
	xpand = atoi(is);
	lx = lx * xpand;
	ly = ly * xpand;
	ndx=ndx * xpand;
	ndy=ndy * xpand;
	return(0);
}
doshrink(is,ty)
char		*is;
int		*ty;
{
	while(*is++ != '=')	;
	shrink = atoi(is);
	lx = lx/shrink;
	ly = ly/shrink;
	ndx = ndx/shrink;
	ndy = ndy/shrink;
	return(0);
}
doset()
{
	ixr = xmax - xmin;
	iyr = ymax - ymin;
	ndx = notset("ndx",ndx,5);
	if(ixr % ndx) {
		prwho(" ndx = %d does not divide xrange = %d evenly\n",ndx,ixr);
		}
	ndy = notset("ndy",ndy,5);
	if(iyr % ndy) {
		prwho(" ndy = %d does not divide yrange = %d evenly\n",ndy,iyr);
		}
	if( (ly > 35 && lx > 80) || (ly >50 && lx > 60) )
	prwho(" lx = %d and ly = %d will not fit a 8.5 by 11 page.\n",lx,ly);
	setgraph(lx,ly,ndx,ndy,xmin,xmax,ymin,ymax);
	prwho(" Graph paramenters set\n");
	redraw = ndread = 0;
	return(0);
}
notset(is,ov,dv)
char	*is;
int	ov;
int	dv;
{
	if(ov == 0)	{
		prwho(" '%s' <set to> '%d'\n",is,dv);
		return(dv);
		}
	else		return(ov);
}
doread(is)
char	*is;
{
	auto	char	ls[BUFSIZ];
	auto	int	recin = 0;
	if(redraw && !strchr(is,'!'))	{
		errmsg(nochange,is);
		catchsig();
		}
	if(isnull(ifn))				{
		errmsg("doread <no input file>\n");
		catchsig();
		}
	if(!(ifp=efopen(ifn,"r"))) 	{
		catchsig();
		}
	recin = 0;
	if(isnull(fm))		{
		errmsg("doread <no format for read>\n");
		catchsig();
		}
/**/
	xscale = xscale ? xscale : 1;
	yscale = yscale ? yscale : 1;
/**/
	while(fgets(ls,MAXREC,ifp)) {
		recin += 1;
		if(*ls == '$') {
			recin -= 1;
			if(kenv.flags3) fprintf(stderr,"%s",ls);
			continue;
			}
		if(xisy(fm,"free")) {
			dgetw(&yy,&xx,yvar,xvar,ls);
			}
		else 	{
			sscanf(ls,fm, &xx, &yy);
			}
		if(xyswap)	{
			zz = xx;
			xx = yy;
			yy = zz;
			}
		if(recin==1) { 
			xlower = xupper = xx;
			ylower = yupper = yy;
			}
		/* establish limits */
		if(xx > xupper) xupper = xx;
		if(xx < xlower) xlower = xx;
		if(yy > yupper) yupper = yy;
		if(yy < ylower) ylower = yy;
		/* scale */
		xx = xx * xscale;
		yy = yy * yscale;
		/* list ? input record */
		if(kenv.flags1) fprintf(stderr,
			"xx = %g yy = %g from %s\n",xx,yy,ls);
/**/
		datain(symfill,symdraw,xx,yy);
/**/
	}
	ndread = 0;
	fclose(ifp);
	xrange = xupper - xlower;
	yrange = yupper - ylower;
	if(kenv.prompt) prwho(" %d lines read from %s\n",recin,ifn);
	return(0);
}
char	*
setifn(is)
char	*is;
{
	return(strcpy(ifn,strcnd(is)));
}
doprint(is)
char	*is;
{
	if(ndread && !strchr(is,'!'))	{
		errmsg(noread,is);
		catchsig();
		}
	if(redraw && !strchr(is,'!'))	{
		errmsg(nochange,is);
		catchsig();
		}
	prwho(" Print to %s requested\n",ofn);
	graphit(nsfxx,nsfyy,xtitle,ytitle,ghead,ofp);
	if(kenv.flags2) fprintf(ofp,docform,"",ifn,xvar,yvar);
	putc('\f',ofp);
	fflush(ofp);
	return(ZERO);
}
dograph(is)
char	*is;
{
	if(ndread && !strchr(is,'!'))	{
		errmsg(noread,is);
		catchsig();
		}
	if(redraw && !strchr(is,'!'))	{
		errmsg(nochange,is);
		catchsig();
		}
	graphit(nsfxx,nsfyy,xtitle,ytitle,ghead,stdout);
	fflush(stdout);
	if(kenv.flags2) fprintf(stdout,docform,"",ifn,xvar,yvar);
	return(0);
}
doso(is)
char	*is;
{
	auto	FILE	*fp;
	while(*is++ != '=')	;
	if(!(fp = efopen(is,"r")))	catchsig();
	rdcmd(fp);
	fclose(fp);
	return(ZERO);
}
setform(is)
char	*is;
{
	while(*is++ != '=')	;
	return(gform(atoi(is)));
}
FSETS *
fsetsget(is)
char	*is;
{
	REG		FSETS	*fsx = fsb;
	while(fsx < fsu)	{
	if(*is == *fsx->fname &&
		strncmp(is,fsx->fname,fsx->fnsize) == 0)
			return(fsx);
	fsx += 1;
	}
	return(NULL);
}
xdoshell(is)
char	*is;
{
	if(*is == '!')	++is;
	return(doshell(is,NULL,NULL));
}
dgetw(yv,xv,ny,nx,is)
double	*yv;
double	*xv;
int	ny;
int	nx;
char	*is;
{
	REG		char	*isx = is;
	REG		int	var = 1;
	auto	double	ret;
	while(*isx != ZERO)
	if(isdigit(*isx) || *isx == '.' || *isx == '-')			{
		ret = atof(isx);
		if(var == ny)	*yv = ret;
		else
		if(var == nx)	*xv = ret;
/**/
if(kenv.diagno & DA) 	printf("yv = %g xv = %g ",*yv,*xv);
if(kenv.diagno & DB)	printf("%s ",isx);
if(kenv.diagno & DC)	printf("var %d ret %g ny = %d nx = %d",
							var,ret,ny,nx);
if(kenv.diagno)			printf("\n");
/**/
		while(isdigit(*isx) || *isx == '.' || *isx == '-')	++isx;
		var += 1;
		}
	else	++isx;
	return(ZERO);
}
help(is)
char	*is;
{
	return(hint(kenv.pname,""));
}
