/*COMLIB*/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
/**/
/*STATIC*/
static		char	*cfn;		/* current file name */
/*EXTERN*/
extern		KENV	kenv;
/**/
char	*
getcfn()		/* return the current file name */
{
	return(cfn);
}
/**/
dolist(argc,argv,func)
int		argc;
char	*argv[];
FUNCP	func;
{
	auto	int	i = 0;
	auto	char	*ws = NULL;
/**/
	for(i = 1; i < argc; i++)
	if(argv[i] == NULL)	continue;
	else
	if(strcmp(argv[i],"-") == 0)	ws = stradd(ws,argv[i]);
	else
	if(strncmp(argv[i],"-",1) == 0)	continue;
	else					ws = stradd(ws,argv[i]);
	if(isnull(ws))			ws = stradd(ws,"-");
	return(dox(ws,func));
}
dox(is,func)
char	*is;
FUNCP	func;
{
	auto	char	*ws;
	auto	int		nf = 0;
	auto	FILE	*fp = NULL;
	auto	char	*mode = kenv.dosdos ? "rb" : "r" ;
	auto	char	*ifb = NULL;
/**/
	ws = emalloc(FNMSIZ,"dox");
/**/
	strcnd(is);
/**/
	while((int)(is = xgnc(cfn = ws,ws+FNMSIZ-1,is,' ')))	{
/**/
/**/
		if(strcmp(ws,"-") == 0)	fp = stdin;
		else					fp = efopen(ws,mode);
/**/
		if(!fp)					fubar(FUBAR);
/**/
#ifdef	__MSDOS__
		ifb = ksetvbuf(fp,ifb,_IOFBF,kenv.blockd);
#endif	/*__MSDOS__*/
/**/
		(*func)(fp,"barf");
/**/
		if(fileno(fp) >= ZERO) fp = xfclose(fp);
/**/
		nf += 1;
/**/
		}
/**/
	if(nf == 0)	{
		cfn = "-";
		fp = stdin;
#ifdef	__MSDOS__
		ifb = ksetvbuf(fp,ifb,_IOFBF,kenv.blockd);
#endif	/*__MSDOS__*/
		(*func)(fp);
		nf += 1;
		}
/**/
	free_if(ifb);
/**/
	return(nf);
}
#ifdef	RDLIST
rdlist(is,func)
char	*is;
FUNCP	(*func)();
{
	auto	FILE	*ifp = NULL;
	auto	FILE	*xfp = NULL;
	auto	char	ls[FNMSIZ];
	auto	int		nf = 0;
	strcnd(is);
	if(isnull(is))					ifp = stdin;
	else
	if(strcmp(is,"-") == 0)			ifp = stdin;
	else
	if(!(ifp = efopen(is,"r")))		fubar(FUBAR);
	while(fgetls(ls,ls+FNMSIZ-1,ifp))	{
		strcnd(ls);
		if(isnull(ls))				continue;
		if(!(xfp = efopen(cfn = ls,"r")))	
									fubar(FUBAR);
		(*func)(xfp);
		if(fileno(xfp) >= ZERO) xfp = xfclose(xfp);
		nf += 1;
		}
	if(fileno(ifp) >= ZERO) 	ifp = xfclose(ifp);
	return(nf);
}
#endif	RDLIST

