/*COMLIB*/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#define     NSTACK  128
/*EXTERN*/
/*TYPEDEF*/
typedef long    STACK;
/*STATIC*/
static  STACK   stk[NSTACK];
static  STACK   *stx = stk;
static  STACK   *stu = &stk[NSTACK-1];
static  char    *over = "<stack overflow>\n";
static  char    *empty = "<stack empty>\n";
static  FUNCP   ferr = (FUNCP) abort;
/**/
int *
dstclr()                /* clear the stack */
{
	stx = stk;
	return( (int *) stx);
}
FUNCP dsterr(fu)	   /* set error function */
FUNCP	fu;
{
	auto	FUNCP pu = ferr;
	ferr = fu;
	return(pu);
}
STACK
dstpush(n)             /* place value on stack */
STACK   n;
{
	if(stx < stu) return(*stx++ = n);
	errmsg(over);
/*  CTEXT
	return((*ferr)) does NOT work.
*/
	return( (STACK) (*ferr)());
}
STACK
dstpop()        /* get top value from stack */
{
	if(stx > stk) return(*--stx);
	errmsg(empty);
	return( (STACK) (*ferr)());
}
#ifdef      TEST
fubar()
{
	puts("fubar");
	return(-1);
}
main()
{
	STACK   dstpop(), dstpush();
	long    atol();
	char    line[BUFSIZ];
	while(fputc('?',stderr),gets(line))
	switch(line[0])
	{
	case    'q':    exit(0);
	case    'a':    printf("%07o\n",dsterr(abort));
					break;
	case    't':    printf("%07o\n",dsterr(fubar));
					break;
	case    'p':    dstpush(atol(line+1));break;
	case    'f':    printf("%ld\n",dstpop());break;
	default:        puts("??");break;
	}
	exit(0);
}
#endif
