/*COMLIB*/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
/**/
#define		LFOLD	1
#define		LLINE	2
/**/
static		char	*rn;	/* routine name */
static		NOSIGN	er;		/* error switch */
/**/
extern		KENV	kenv;
/**/
fgetlerr()			/* return error switch */
{
	return(er);
}
char	*
fgetlf(os,us,fp)	/* line with escape extended */
char	*os;
char	*us;
FILE	*fp;
{
	er = NO;
	rn = "fgetlf";
	return(fgetlx(os,us,fp,LFOLD));
}
char	*
fgetls(os,us,fp)	/* raw line */
char	*os;
char	*us;
FILE	*fp;
{
	er = NO;
	rn = "fgetls";
	return(fgetlx(os,us,fp,LLINE));
}
char	*
fgetlx(os,us,fp,ty)
char	*os;
char	*us;
FILE	*fp;
NOSIGN	ty;
{
	REG		char	*osx = os;
	REG		char	*usx = us - 1;
	REG		int		cx = ZERO;
	REG		int		lx = ZERO;
	while(osx < usx && (cx = getc(fp)) != EOF)	{
	if(cx == CR)	;
	else
	if(cx == LF)	{
		if(lx == ESC && ty == LFOLD)	lx = osx[-1] = ' ';
		else							break;
		}
	else			*osx++ = lx = cx;
	}
/**/
	*osx = ZERO;
/**/
	if(osx >= usx)	{
		errmsg("%s <long line>\n",rn);
		er = YES;
		return(NULL);
		}
/**/
	if(cx == EOF && osx == os)	return(NULL);
	else						return(osx);
/**/
}
#ifdef	GETLINES
main()
{
	auto	char	ls[FNMSIZ];
	auto	int		nl = FNMSIZ - 1;
	auto	char	*(*fu)() = fgetlf;
	while(putchar('?'),fflush(stdout),(*fu)(ls,ls+nl-1,stdin))
	switch(ls[0])	{
		case	'<':	fu = fgetls;break;
		case	'>':	fu = fgetlf;break;
		case	'q':	fclose(stdin);
						break;
		case	'!':	system(ls+1);
						break;
		case	'#':	nl = atoi(ls+1);
						break;
		default:		puts(ls);
	}
	exit(ZERO);
}
#endif	GETLINES
char	*
fgetlw(os,us,fp)	/* get word from file */
char	*os;
char	*us;
FILE	*fp;
{
	REG		char	*osx = os;
	REG		char	*usx = us;
	auto	int	cx;
/**/
	*osx = ZERO;
/**/
	while((cx = getc(fp)) != EOF)
	if(isspace(cx))	continue;
	else			break;
/**/
	if(cx == EOF)	return(NULL);
	else			ungetc(cx,fp);
/**/
	while(osx < usx && (cx = getc(fp)) != EOF)
	if(isspace(cx))	break;
	else			*osx++ = cx;
/**/
	*osx = ZERO;
/**/
	if(osx >= usx)	{
		errmsg("fgetlw <truncation>\n");
		return(NULL);
		}
/**/
	if(osx > os)	return(osx);
	else			return(NULL);
/**/
}
