/*COMLIB*/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
extern		KENV	kenv;
/**/
#define		FLAG	'@'
static		int		fc = FLAG;
xescfc(ty)			/* set flag character for escape printing */
int		ty;
{
	if(isprint(ty))	return(fc = ty);
	else			return(FLAG);
}
char	*
funxesc(is,fp)		/* list non print to file */
char	*is;
FILE	*fp;
{
	register	unsigned	char	*isx = is;
	while(*isx != ZERO)
	if(*isx >= '\000' && *isx <= '\037')    {
		putc(fc,fp);
		putc(*isx | '\100',fp);
		isx += 1;
		}
	else
	if(*isx >= '\177')						{
		fprintf(fp,"\\%03o",*isx++);
		}
	else    putc(*isx++,fp);
	putc('\n',fp);
	return(is);
}
char	*
sunxesc(os,us,is)    /* convert to ^X escapes */
char	*os;
char	*us;
char	*is;
{
	register    unsigned	char    *osx = os;
	register    unsigned	char    *usx = us;
	register    unsigned	char    *isx = is;
	while(osx < usx && *isx != ZERO)
	if(*isx >= '\000' && *isx <= '\037')    {
		*osx++ = fc;
		*osx++ = *isx++ + '\100';
		}
	else
	if(*isx >= '\177')						{
		sprintf(isx,"\\%03o",*isx++);
		osx += 4;
		}
	else    *osx++ = *isx++;
	*osx = ZERO;
	return(os);
}
char	*
unxesc(os,us,is)
char	*os;
char	*us;
char	*is;
{
	return(sunxesc(os,us,is));
}
#ifdef	TEST
main()
{
	auto	char	ls[BUFSIZ];
	auto	char	ws[BUFSIZ];
	while(putchar('?'),fflush(stdout),gets(ls))	{
		puts(sunxesc(ws,ws+BUFSIZ-1,xesc(ls)));
		funxesc(ws,stderr);
	}
}
#endif
