#include	<stdio.h>
#include	<bios.h>
#include	<fcntl.h>
#define		FUBAR		69
#define		P_STAT		2
#define		P_INIT		1
#define		P_SEND		0
#define		P_PORT		0
char		buf[BUFSIZ];
main(argc,argv)
int		argc;
char	*argv[];
{
	auto	int		ifd;
	auto	int		nci;
	auto	int		ix;
	auto	int		jx;
	auto	int		rt;
	rt = biosprint(P_INIT,0,P_PORT);
	fuport(rt);
	for(ix = 1; ix < argc; ix++)	{
		ifd = open(argv[ix],O_RDONLY | O_BINARY);
		if(ifd < 0)	{
			perror(argv[ix]);
			exit(FUBAR);
			}
		while((nci = read(ifd,buf,BUFSIZ)) >= 1)	{
			for(jx = 0; jx < nci; jx++)				{
				rt = biosprint(P_SEND,buf[jx],P_PORT);
				fuport(rt);
				}
			}
		if(nci < 0)	{
			perror(argv[ix]);
			exit(FUBAR);
			}
		close(ifd);
		}
}
fuport(cx)
int		cx;
{
	auto	int		act = 0;
	if(cx & 0x01)	{ fputs("<time out>\n",stderr); }
	if(cx & 0x08)	{ fputs("<i/o error>\n",stderr); act = FUBAR; }
	/* if(cx & 0x10)	{ fputs("<selected>\n",stderr); } */
	if(cx & 0x20)	{ fputs("<out of paper>\n",stderr); act = 1; }
	if(cx & 0x40)	{ fputs("<acknowledged>\n",stderr); }
	if(cx & 0x80)	{ fputs("<not busy>\n",stderr); }
	if(act == 1)	{
		fputs("<correct condition; carriage return to start> ",stderr);
		while(getc(stdin) != '\n')	;
		}
	if(act == FUBAR)	{
		exit(FUBAR);
		}
	return(cx);
}
